/*
 * HandCodedController.java
 *
 * Created on September 16, 2007, 7:33 PM
 * Submitted to IEEE CEC 2007 Car Racing Competition
 *
 */

/**
 *
 * @author frank
 */

/*
 *
 *
Testing the controller on its own...
 Solo score: 20.63
Testing the controller against the hard-coded heuristic controller...
2007-09-17 01:24:37.903 java[4569] CFLog (0): CFMessagePort: bootstrap_register(): failed 1103 (0x44f), port = 0xfc03, name = 'java.ServiceProvider'
See /usr/include/servers/bootstrap_defs.h for the error codes.
2007-09-17 01:24:37.903 java[4569] CFLog (99): CFMessagePortCreateLocal(): failed to name Mach port (java.ServiceProvider)
 Score against heuristic controller: 16.085
Testing the controller against the the fixed evolved competitor (fixedcompetitor.xml)...
fixedcompetitor.xml is not a class name; trying to load a wox definition with that name.
 Score against fixed evolved competitor: 17.44


Competition score (mean of the above): 18.051666666666666
 *
 */

package frankfuentes;


import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import simplerace.*;

public class HandCodedController extends KeyAdapter implements Controller, Constants {
    private boolean isGetNextPoint = false;
    private boolean isBreakTime = false;
    private boolean stateCorrecting = false;
    private boolean stateForwardDirection;
    private int saveTopSpeed;
    
    private int GetNextPointCount=0;
    
    private boolean isOtherVehicleIsPresent = false;
    
    private boolean isLockedIn;
    
    public void reset() {}
    private int count = 0;
    private boolean reverse = false;
    
    private Vector2d positionOtherCar;
    private Vector2d positionMyCar;
    private Vector2d positionTarget;
    private Vector2d positionNextTarget;
    private int stateSteering = 0;
    
    private double[] distancesLocked =      {150, 100,  80,  60, 40, 20};
    private double[] absSpeedsLocked =      {  8,   7,   6,   5,  4,  3};
    private double[] distancesNotLocked =   {200, 150, 100,   50, 20};
    private double[] absSpeedsNotLocked =   {  5,   4,   3,  2.5,  2};
    private double[] distancesNextPointL =  {200,100,  80,  60,  40, 35, 29, 20,  10}; // locked
    private double[] absSpeedsNextPointL =  {  9,  7,   6,   5, 4.5,  3,  2,  1,  0.5}; // locked
    private double[] distancesNextPointNL = {200, 150, 100, 50, 20, 10}; // not locked
    private double[] absSpeedsNextPointNL = {  5,   4,   3,  2,  1, 0.5 }; // not locked
    private double[] distances;
    private double[] absSpeeds;
    
    double distMeToTarget=0;
    double distMeToNextTarget=0;
    double distOtherToTarget=0;
    double distOtherToNextTarget=0;
    double absSpeed;
    
    public int control(SensorModel inputs) {
        int driving;
        int steering;
        boolean lockedIn = false;
        double angle, distance;
        double speed;
        
        speed = inputs.getSpeed();
        absSpeed = Math.abs(speed);
        positionMyCar = inputs.getPosition();
        positionTarget = inputs.getNextWaypointPosition();
        distMeToTarget = positionTarget.dist(positionMyCar);
        positionNextTarget = inputs.getNextNextWaypointPosition();
        distMeToNextTarget = positionNextTarget.dist(positionMyCar);
        
        if( inputs.otherVehicleIsPresent() ) {
            isOtherVehicleIsPresent = true;
            positionOtherCar = inputs.getOtherVehiclePosition();
            distOtherToTarget = positionTarget.dist(positionOtherCar);
            distOtherToNextTarget = positionNextTarget.dist(positionOtherCar);
            if(0.9*distMeToTarget > distOtherToTarget) {
                isGetNextPoint = true;
                GetNextPointCount++;
                if(GetNextPointCount > 100) {
                    isGetNextPoint = false;
                }
            } else {
                isGetNextPoint = false;
                GetNextPointCount = 0;
            }
        }
        
        if(isBreakTime) {
            return brake(speed);
        }
        
        if(isGetNextPoint) {
            angle = inputs.getAngleToNextNextWaypoint();
            distance = inputs.getDistanceToNextNextWaypoint();
            positionTarget = inputs.getNextNextWaypointPosition();
            distMeToTarget = positionTarget.dist(positionMyCar);
            distOtherToTarget = positionTarget.dist(positionOtherCar);
        } else {
            angle = inputs.getAngleToNextWaypoint();
            distance = inputs.getDistanceToNextWaypoint();
        }
        
        
        isLockedIn = false;
        if( Math.abs(angle) < toRadian(90) ) {
            if(speed >= 0) {
                // momentum is moving towards the target
                steering = angle > 0 ? 0 : 2;
                driving = 2;
                // only lock in if heading towards the target
                if(Math.abs(angle) < toRadian(5)) {
                    steering = 1;
                    isLockedIn = true;
                }
            } else {
                // momentum is moving away from the target
                if(speed > -100) { // disabled
                    // if I am moving very slow (small momentum) then reverse direction
                    steering = angle > 0 ? 2 : 0;
                    driving = 2;
                } else {
                    // if I am moving faster then I want to maintain momentum - don't reverse direction
                    steering = angle > 0 ? 0 : 2;
                    driving = brake(speed);
                }
            }
        } else {
            //System.out.println("reverse " + count++);
            if(speed <= 0) {
                steering = angle > 0 ? 0 : 2;
                driving = 0;
                // only lock in if heading towards the target
                if(Math.abs(angle) > toRadian(175)) {
                    //System.out.println("locked in - speed = " + (int)speed);
                    steering = 1;
                    isLockedIn = true;
                }
            } else {
                // momentum is moving away from the target
                if(speed < 100) { // disabled
                    // if I am moving very slow (small momentum) then reverse direction
                    steering = angle > 0 ? 2 : 0;
                    driving = 0;
                } else {
                    // if I am moving faster then I want to maintain momentum - don't reverse direction
                    //System.out.println("Maintain reverse momentum");
                    steering = angle > 0 ? 0 : 2;
                    driving = brake(speed);
                }
            }
        }
        
        if(isLockedIn) {
            distances = distancesLocked;
            absSpeeds = absSpeedsLocked;
        } else {
            distances = distancesNotLocked;
            absSpeeds = absSpeedsNotLocked;
        }
        
        if(shouldBrake()) {
            driving = brake(speed);
        }
        
        
        if (isOtherVehicleIsPresent
                && isGetNextPoint
                ) {
            if(isLockedIn) {
                distances = distancesNextPointL;
                absSpeeds = absSpeedsNextPointL;
            } else {
                distances = distancesNextPointNL;
                absSpeeds = absSpeedsNextPointNL;
            }
            
            if(shouldBrake()) {
                driving = brake(speed);
            }
        }
        
        if( true ) {
            // correct to avoid circling around target using a "3 point turn"
            if( needsCorrecting(distance, angle, speed) ) {
                if( stateCorrecting == false ) {
                    stateCorrecting = true;
                    stateForwardDirection = speed >=0 ? true : false;
                    stateSteering = angle > 0 ? 2 : 0;; // reverse the steering
                }
                steering = stateSteering;
                if(absSpeed < 3)
                    driving = stateForwardDirection ? 2 : 0; // accelerate in whatever direction we are heading
            } else {
                if(stateCorrecting == true) {
                    stateCorrecting = false;
                    driving = stateForwardDirection ? 0 : 2; // reverse the direction
                }
            }
        }
        
        return driving * 3 + steering;
    }
    
    private boolean shouldBrake() {
        for (int i = absSpeeds.length-1; i >=0 ;i--) {
            if(distMeToTarget < distances[i]) {
                return absSpeed > absSpeeds[i] ? true : false;
                
            }
        }
        return false;
    }

    private double toRadian(double degree) {
        return degree * (Math.PI/180);
    }
    
    private double toDegree(double radian) {
        return radian * (180/Math.PI);
    }
    
    private double distance(Vector2d v1, Vector2d v2) {
        return (v1.x - v2.x) + (v1.y + v2.y);
    }
    
    private int brake(double speed) {
        int driving = 1;
        if(speed > 0) {
            driving = 0;
        } else if (speed < 0) {
            driving = 2;
        } else if (speed == 0) {
            driving = 1;
        }
        return driving;
    }
    
    private int accelerate(double speed) {
        int driving = 1;
        if(speed > 0) {
            driving = 2;
        } else if (speed < 0) {
            driving = 0;
        } else if (speed == 0) {
            driving = 2;
        }
        return driving;
    }
    
    private boolean needsCorrecting(double distance, double angle, double speed) {
        if(stateCorrecting) {
            if( (Math.abs(angle) < toRadian(20) || Math.abs(angle) > toRadian(160)) // between +-20 or +-160
            ) {
                // the angle is good so quit correcting
                return false;
            } else {
                // the angle is not good enough so continue correcting
                return true;
            }
        } else {
            if( (distance < 0.08 && distance > 0.04) // in this range
            && (Math.abs(angle) > toRadian(30) && Math.abs(angle) < toRadian(150)) // between 30 and 150
            ) {
                // we are in close and at a bad angle of attack so start correcting
                return true;
            } else {
                return false;
            }
        }
        
    }
}